// rssdemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "rssdemo.h"
#include "rssdemoDlg.h"
#include <comdef.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#import "..\com_dll\RSSParse_VC6_com.dll" no_namespace

///////////////////
#define WM_MYNOTIFY0 WM_USER + 20
#define WM_MYNOTIFY1 WM_USER + 21

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
IRSSParse *m_Parse[2];

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRssdemoDlg dialog

CRssdemoDlg::CRssdemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRssdemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRssdemoDlg)
	m_strCombo1 = _T("");
	m_strCombo2 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRssdemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRssdemoDlg)
	DDX_Control(pDX, IDC_RICHEDIT1, m_RichEdit1);
	DDX_Control(pDX, IDC_EXPLORER1, m_Web);
	DDX_CBString(pDX, IDC_COMBO1, m_strCombo1);
	DDX_CBString(pDX, IDC_COMBO2, m_strCombo2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRssdemoDlg, CDialog)
	//{{AFX_MSG_MAP(CRssdemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(ID_START, OnStart)
	ON_BN_CLICKED(ID_SAVE2FILE1, OnSave2file1)
	ON_BN_CLICKED(ID_START2, OnStart2)
	ON_BN_CLICKED(ID_SCAN1, OnScan1)
	ON_BN_CLICKED(ID_SCAN2, OnScan2)
	ON_BN_CLICKED(ID_WEBBROW1, OnWebbrow1)
	ON_BN_CLICKED(ID_START3, OnStart3)
	ON_BN_CLICKED(ID_START4, OnStart4)
	ON_BN_CLICKED(ID_SAVE2FILE2, OnSave2file2)
	ON_BN_CLICKED(ID_WEBBROW2, OnWebbrow2)
	ON_BN_CLICKED(ID_SCAN3, OnScan3)
	ON_BN_CLICKED(ID_SCAN4, OnScan4)
	ON_BN_CLICKED(ID_SETTIMER1, OnSettimer1)
	ON_BN_CLICKED(ID_KILLTIMER1, OnKilltimer1)
	ON_BN_CLICKED(ID_KILLTIMER2, OnKilltimer2)
	ON_BN_CLICKED(ID_SETTIMER2, OnSettimer2)
	ON_BN_CLICKED(ID_RESULT, OnResult)
	ON_BN_CLICKED(ID_BASETEST, OnBasetest)
	ON_WM_CLOSE()
	ON_BN_CLICKED(ID_PARSEBUFFER, OnParsebuffer)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MYNOTIFY0, OnMyNotify0)
	ON_MESSAGE(WM_MYNOTIFY1, OnMyNotify1)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRssdemoDlg message handlers

BOOL CRssdemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	CoInitialize(NULL); 

	CLSID clsid;
	CLSIDFromProgID(OLESTR("RSSParse_VC6_com.RSSParse"),&clsid);
	// ﴴ
	IClassFactory* p_classfactory;
	CoGetClassObject(clsid, CLSCTX_INPROC_SERVER, NULL, IID_IClassFactory, (LPVOID*)&p_classfactory);
	p_classfactory->CreateInstance(NULL,__uuidof(IRSSParse), (LPVOID*)&m_Parse[0]);
	p_classfactory->CreateInstance(NULL,__uuidof(IRSSParse), (LPVOID*)&m_Parse[1]);


	m_Parse[0]->SetNotify((long)GetSafeHwnd(), (long)WM_MYNOTIFY0);
	m_Parse[1]->SetNotify((long)GetSafeHwnd(), (long)WM_MYNOTIFY1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRssdemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRssdemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRssdemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
void CRssdemoDlg::OnStart() 
{
	StartSyn(0);
}
void CRssdemoDlg::OnStart2() 
{
	StartAsyn(0);
}
void CRssdemoDlg::OnStart3() 
{
	StartSyn(1);
}
void CRssdemoDlg::OnStart4() 
{
	StartAsyn(1);
}
// ͬ
void CRssdemoDlg::StartSyn(int id) 
{
	m_RichEdit1.SetSel(0, -1);   // ձ༭
	m_RichEdit1.Clear();

	UpdateData(true);
	BSTR bstr = m_strCombo1.AllocSysString();
	m_Parse[id]->SetChannel(bstr);
	SysFreeString(bstr);

	ShowStatus("ڽ"+m_strCombo1);
	m_Parse[id]->Start();
	m_Parse[id]->IsReady(VARIANT_FALSE);  // ͬʽ

	ShowStatus("......");
}
// 첽
void CRssdemoDlg::StartAsyn(int id) 
{
	m_RichEdit1.SetSel(0, -1);   // ձ༭
	m_RichEdit1.Clear();

	UpdateData(true);
	BSTR bstr = m_strCombo1.AllocSysString();
	m_Parse[id]->SetChannel(bstr);
	SysFreeString(bstr);
	ShowStatus("ڽ"+m_strCombo1);
	m_Parse[id]->Start();
	if (m_Parse[id]->IsReady(VARIANT_TRUE)) // 첽ʽ
		ShowStatus("......");
}
LRESULT  CRssdemoDlg::OnMyNotify0(WPARAM w,LPARAM l)
{
	if (w == 1)
	{
		_bstr_t bstr = 	m_Parse[0]->WhichSpec();
		ShowStatus("ɣ 1 Ϣ֪ͨ......ѭ¹淶");
		ShowStatus(bstr.copy());
	}
	if (w == -1)
		ShowStatus("ʧܣ 1 Ϣ֪ͨ......");
	return 0;
}
LRESULT  CRssdemoDlg::OnMyNotify1(WPARAM w,LPARAM l)
{
	if (w == 1)
	{
		_bstr_t bstr = 	m_Parse[1]->WhichSpec();
		ShowStatus("ɣ 2 Ϣ֪ͨ......ѭ¹淶");
		ShowStatus(bstr.copy());
	}
	if (w == -1)
		ShowStatus("ʧܣ 2 Ϣ֪ͨ......");
	return 0;
}
void CRssdemoDlg::OnSave2file1() 
{
	Save2file(0);
}
void CRssdemoDlg::OnSave2file2() 
{
	Save2file(1);
}
void CRssdemoDlg::Save2file(int id) 
{
	m_RichEdit1.SetSel(0, -1);   // ձ༭
	m_RichEdit1.Clear();

	if (m_Parse[id]->IsReady(VARIANT_TRUE)) // 첽ʽ
	{
		CString str;
		str.Format("result%d.txt", id);
		BSTR bstr = str.AllocSysString();
		m_Parse[id]->WriteNodes2File(bstr);
		SysFreeString(bstr);
		ShowStatus("ļ......"+str);
	}
	else
		ShowStatus("δɽ......");
	
}

void CRssdemoDlg::OnScan1()
{
	Scan1(0);
}
void CRssdemoDlg::OnScan2() 
{
	Scan2(0);
}
void CRssdemoDlg::OnScan3()
{
	Scan1(1);
}
void CRssdemoDlg::OnScan4() 
{
	Scan2(1);
}
CString CRssdemoDlg::BSTRToString(BSTR bstr) 
{
	char *pTmp;
	pTmp = _com_util::ConvertBSTRToString(bstr);
	CString str = pTmp;
	delete pTmp;
	return str;
}
// ڵ(item)
void CRssdemoDlg::Scan1(int id) 
{
	m_RichEdit1.SetSel(0, -1);   // ձ༭
	m_RichEdit1.Clear();
	if (m_Parse[id]->IsReady(VARIANT_TRUE)) //  첽
	{
		CString tmp;
		m_Parse[id]->SetFirstNodePos();
		while (1)
		{
			_bstr_t node = m_Parse[id]->GetNextNode();
			if (node.length() <=0) // ־
				break;
			tmp = BSTRToString(node.copy());
			tmp += "\r\n  ԣ";
			m_Parse[id]->SetFirstAttributePos();
			while (1)
			{
				_bstr_t attr = BSTRToString(m_Parse[id]->GetNextAttribute(node));
				if (attr.length() <= 0) // ־
					break;
				tmp = BSTRToString(attr.copy());
				tmp += "=";
				_bstr_t strNode = BSTRToString(node.copy());// ɣڵ.
				strNode += ".";
				strNode += attr;
				_bstr_t val = m_Parse[id]->GetAttributeValue(strNode);
				tmp += val;
				tmp += "  ";
			}
			tmp += "\r\n  ݣ";
			_bstr_t content = m_Parse[id]->GetContent(node);
			tmp += BSTRToString(content.copy());

			ShowStatus(tmp);
		}
		ShowStatus("!");
	}
}
// ڵ(item)
void CRssdemoDlg::Scan2(int id) 
{
	m_RichEdit1.SetSel(0, -1);   // ձ༭
	m_RichEdit1.Clear();

	if (m_Parse[id]->IsReady(VARIANT_TRUE)) //  첽
	{
		CString tmp;
		m_Parse[id]->SetFirstItemPos();
		while (1)
		{
		 _bstr_t node = m_Parse[id]->GetNextItem();
			if (node.length() <=0) // ־
				break;
			tmp = BSTRToString(node.copy());
			tmp += "\r\n  ԣ";
			m_Parse[id]->SetFirstAttributePos();
			while (1)
			{
				_bstr_t attr = m_Parse[id]->GetNextAttribute(node);
				if (attr.length() <=0) // ־
					break;
				tmp += BSTRToString(attr.copy());
				tmp += "=";
				CString strNode = BSTRToString(node.copy()); // ɣڵ.
				strNode += ".";
				strNode += attr;
				attr = strNode.AllocSysString();
				_bstr_t val = m_Parse[id]->GetAttributeValue(attr);
				SysFreeString(attr);
				tmp += val;
				tmp += "  ";
			}
			tmp += "\r\n  ݣ";
			_bstr_t content = m_Parse[id]->GetContent(node);
			tmp += BSTRToString(content.copy());

			ShowStatus(tmp);
		}
		ShowStatus("!");
	}
}

void CRssdemoDlg::OnWebbrow1() 
{
	Webbrow(0);
}
void CRssdemoDlg::OnWebbrow2() 
{
	Webbrow(1);
}
void CRssdemoDlg::Webbrow(int id) 
{
	if (m_Parse[id]->IsReady(VARIANT_TRUE)) //  첽
	{
		CString str;
		CString title, link, pubDate, description;
		CString html = "<html><head>";  // ҳͷ
		html += "<meta http-equiv='content-type' content='text/html; charset=gb2312'/>";
		html += "<title>ֻһССĲ</title>";
		html += "</head><body>";
		for (int i=0; i<m_Parse[id]->GetItemCount(); i++)   // еitem
		{
			str.Format("rss/channel/item[%d]/title", i);
			BSTR node = str.AllocSysString();  // CString2BSTR
			_bstr_t content = m_Parse[id]->GetContent(node);
			SysFreeString(node);
			title = content.copy();

			str.Format("rss/channel/item[%d]/link", i);
			node = str.AllocSysString();  // CString2BSTR
			content = m_Parse[id]->GetContent(node);
			SysFreeString(node);
			link = content.copy();

			str.Format("rss/channel/item[%d]/pubDate", i);
			node = str.AllocSysString();  // CString2BSTR
			content = m_Parse[id]->GetContent(node);
			SysFreeString(node);
			pubDate = content.copy();

			str.Format("rss/channel/item[%d]/description", i);
			node = str.AllocSysString();  // CString2BSTR
			content = m_Parse[id]->GetContent(node);
			SysFreeString(node);
			description = content.copy();

			// ҳ
			html += "<p><a href='" + link + "'>" + title + "</a><br>";
			html += description + " " + pubDate;
			html += "</p>";
			title.Empty();
			link.Empty(); 
			pubDate.Empty();
			description.Empty();
		}
		html += "</body></html>";
		str.Format("test%d.html", id);
		CString url = Save2File(str, html);
		if (!url.IsEmpty())
			m_Web.Navigate(url, NULL, NULL, NULL, NULL);
	}
}
CString CRssdemoDlg::Save2File(CString name, CString &html)
{
	char buf[MAX_PATH];
	GetCurrentDirectory(MAX_PATH, buf);
	CString path = buf;

	CFile file;
	CString filename = path + "/" + name;
	if (file.Open(filename, CFile::modeCreate|CFile::modeWrite))
	{
		file.WriteHuge(html, html.GetLength());
		file.Close();
		return filename;
	}
	else
		return "";
}
void CRssdemoDlg::ShowStatus(CString str) 
{
	m_RichEdit1.SetSel(-1,-1);
	m_RichEdit1.ReplaceSel(str + "\r\n");
	return;
}

void CRssdemoDlg::OnSettimer1() 
{
	OnSettimer(0);
}
void CRssdemoDlg::OnKilltimer1() 
{
	OnKilltimer(0);
}
void CRssdemoDlg::OnSettimer2() 
{
	OnSettimer(1);
}
void CRssdemoDlg::OnKilltimer2() 
{
	OnKilltimer(1);
}
void CRssdemoDlg::OnSettimer(int nid) 
{
	m_Parse[nid]->SetTimer(10); // 
}
void CRssdemoDlg::OnKilltimer(int nid) 
{
	m_Parse[nid]->KillTimer();
}
// 
void CRssdemoDlg::OnResult() 
{
	m_RichEdit1.SetSel(0, -1);   // ձ༭
	m_RichEdit1.Clear();

	UpdateData(true);

	BSTR node = m_strCombo2.AllocSysString();
	CString tmp = m_strCombo2; // 

	tmp += "\r\n  ԣ";
	m_Parse[0]->SetFirstAttributePos();
	while (1)
	{
		_bstr_t attr = m_Parse[0]->GetNextAttribute(node);
		if (!attr) // 
			break;
		tmp += attr;
		tmp += "=";
		CString strNode = node; // ɣڵ.
		strNode += ".";
		strNode += attr;
		attr = strNode.AllocSysString();
		_bstr_t val = m_Parse[0]->GetAttributeValue(attr);
		SysFreeString(attr);
		tmp += val.copy();
		tmp += "  ";
	}
	tmp += "\r\n  ݣ";
	_bstr_t content = m_Parse[0]->GetContent(node);
	tmp += content.copy();

	SysFreeString(node); 
	ShowStatus(tmp);
}
// ԣ
void CRssdemoDlg::OnBasetest() 
{
	m_RichEdit1.SetSel(0, -1);   // ձ༭
	m_RichEdit1.Clear();

	CString tmp;
	_bstr_t bstr;
	tmp = "Feed\r\n";
	tmp += "--------------------------------------------------------------------------\r\n";
	bstr = m_Parse[0]->GetFeedTitle();
	tmp += "\r\nTitle:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetFeedLink();
	tmp += "\r\nLink:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetFeedDescription();
	tmp += "\r\nDescription:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetFeedCopyright();
	tmp += "\r\nCopyright:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetFeedPubDate();
	tmp += "\r\nPubDate:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetFeedLastBuildDate();
	tmp += "\r\nLastBuildDate:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetFeedCategory();
	tmp += "\r\nCategory:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetImageUrl();
	tmp += "\r\nImageUrl:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetImageTitle();
	tmp += "\r\nImageTitle:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetImageLink();
	tmp += "\r\nImageLink:\r\n\t";
	tmp += bstr.copy();
	bstr = m_Parse[0]->GetImageDescription();
	tmp += "\r\nImageDescription:\r\n\t";
	tmp += bstr.copy();
	ShowStatus(tmp);

	CString str;
	tmp = "\r\nItem\r\n";
	tmp += "--------------------------------------------------------------------------\r\n";
	for (int i=0; i<m_Parse[0]->GetItemCount(); i++)
	{
		bstr = m_Parse[0]->GetItemTitle(i);
		str.Format("\r\nItem[%d]/Title:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemLink(i);
		str.Format("\r\nItem[%d]/Link:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemDescription(i);
		str.Format("\r\nItem[%d]/Description:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemAuthor(i);
		str.Format("\r\nItem[%d]/Author:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemCategory(i);
		str.Format("\r\nItem[%d]/Category:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemPubDate(i);
		str.Format("\r\nItem[%d]/PubDate:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemDate(i);
		str.Format("\r\nItem[%d]Ϊ:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemGuid(i);
		str.Format("\r\nItem[%d]/Guid:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
		bstr = m_Parse[0]->GetItemSource(i);
		str.Format("\r\nItem[%d]/Source:\r\n\t", i);
		tmp += str;
		tmp += bstr.copy();
	}
	ShowStatus(tmp);
}

void CRssdemoDlg::OnClose() 
{
CoUninitialize();	
	CDialog::OnClose();
}
CString LoadFromFile(CString filename)  // ȡļ
{

	CString mem;
	CString str;
	mem.Empty();
	CStdioFile f;
	if (f.Open(filename, CFile::modeRead))
	{
		while (f.ReadString(str))
			mem += str + "\n";
		f.Close();
	}
	return mem;
};


/////// 3.0
void CRssdemoDlg::OnParsebuffer() 
{
	// Ƚļװ뻺
	CString text = LoadFromFile("xjlblog.xml");
	if (!text.IsEmpty())
	{
		m_RichEdit1.SetSel(0, -1);   // ձ༭
		m_RichEdit1.Clear();
		//
		BSTR bstr = text.AllocSysString();
		m_Parse[0]->GetRssFromBuffer(bstr);
		SysFreeString(bstr);
		ShowStatus("ڽ"+m_strCombo1);
		m_Parse[0]->Start();
		m_Parse[0]->IsReady(VARIANT_FALSE);  // ͬʽ
		ShowStatus("......");
	}
}
